<?php  
namespace Concrete\Package\LocalizerLocalizeConcrete5Addon\Block\LocalizerLocalizeConcrete5Addon;

defined('C5_EXECUTE') or die(_("Access Denied.")); 
use \Concrete\Core\Block\BlockController;
use Core;

class Controller extends BlockController
{
    protected $btTable = 'btLocalizerCo';

    public function getBlockTypeDescription()
    {
        return t("Make your website multilingual instantly with Localizer.");
    }

    public function getBlockTypeName()
    {
        return t("Localizer");
    }
	
    function view()
	{
		$this->set("content",$this->content);
    }
	
    public function save($args)
    {
		$args['content'] = $this->requestCode($args['email'],$args['password']);
		parent::save($args);
    }	
 	
    public function validate($args)
    {
		$e = Core::make("helper/validation/error");       
		if(empty($args['email'])){
            $e->add(t("* Please enter your email associated with a Localizer account."));
        }
		if(empty($args['password'])){
            $e->add(t("* Please enter your password."));
        }
		
        return $e;
    }
	
	private function parse_http_response($string) 
    { 
        $headers = array();
        $content = '';
        $str = strtok($string, "\n");
        $h = null;
        while ($str !== false) 
		{
            if ($h and trim($str) === '') 
			{                
                $h = false;
                continue;
            }
			
            if ($h !== false and false !== strpos($str, ':'))
			{
                $h = true;
                list($headername, $headervalue) = explode(':', trim($str), 2);
                $headername = strtolower($headername);
                $headervalue = ltrim($headervalue);
				
                if (isset($headers[$headername])) 
                    $headers[$headername] .= ',' . $headervalue;
                else 
                    $headers[$headername] = $headervalue;
            }
			
            if ($h === false) 
			{
                $content .= $str."\n";
            }
			
            $str = strtok("\n");
        }
		
        return array($headers, trim($content));		
    }
	
	private function requestCode($email,$password)
	{
		$code = 'Localizer: Not Activated';
		try
		{
			$postfields = array('Email'=>$email, 'Password'=>$password);
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, 'https://secure.localizer.co/widget/getwidget');
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, false);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

			$result = curl_exec($ch);

			if($result === false)
			{
				$code = "Localizer: There is a problem communicating with the Localizer service.<br>".curl_error($ch);
				
			}else
			{
				if (stristr($result, 'Server Error'))
				{
					$code = "Localizer: There is a problem communicating with the Localizer service.";
				} else
				{
					$code = $result;
				}
			}
		}
		catch(Exception $e)
		{
			$code = "Localizer: Unable to get the integration code.";
		}
		
		return $code;
	}
}